#!/usr/bin/python
#
# This program is distributed under the terms of the GNU General Public License
# Copyright (c) 2013 Barry Brosnihan barry@brosnihan.co.uk
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# Version BETA 1.

import subprocess
import time
import sys
import os
import shlex
import Queue
import threading
import pygame.mixer
import time
import copy
from datetime import datetime

#Variables
#pipe = open('/dev/input/js0','r')
#This pipe is need on my laptop
pipe = open('/dev/input/js1','r')
action = []
spacing = 0
sleep = 0
#sample_dir="/opt/playpi/samples"
sample_dir="/music/samples"
loop_dir="/opt/playpi/loops"
sample_list = []
current_sample_list = []
exitfunction = 1
exitprogram = 1
printoutmenu = 1
printsamplestart = 0
printsampleend = 16
currentsequence = 0
totalsequence = 256
stepstart = 0
stepend = 16
patstart = 0
patend = 16
currentstep = 0
sequencer_status = 0
sequencer_status_display=["Stopped","Playing"]
pygamechannels=32
tempo=220.0
sequencer_list=[[[] for sequencer_list in range(256)] for b in range(totalsequence)]
pattern = []
queueLock = threading.Lock()
buttonQueue = Queue.Queue(10)
sounddict={}
special_sequence_options = ["START","END"]
sequencer_mode = ["Sequencer","Pattern"]
sequencer_mode_current = 0
pattern_sequence = 0

#Pygame Init
pygame.mixer.init(44100, -16, 2, 512)
pygame.mixer.set_num_channels(pygamechannels)
pygame.init()

#Menus
firstmenu = ["H. Start/Stop Sequencer", "1. Sequencer Builder", "2. Pattern Builder", "3. Rebuild Sound Dictionary","4. Change Temp", "5. Load File", "6. Save File", "E. Exit Program"]
sampleaddremovemenu = ["A. Start/Stop Sequencer", "1. ", "2. Pattern Builder", "E. Exit Program"]
menutitle = ["Sequence Builder.","Select Sample.","Add/Remove Sample from Sequence","Pattern Builder.","Pattern Editor"]


# Build the sample list.
rootdir = sample_dir
#Add special options to the start of the list.
for special_item in special_sequence_options:
	sample_list.append(special_item)
# Add the samples to the sample_list
for root, subFolders, files in os.walk(rootdir):
    for file in files:
        sample_list.append(os.path.join(root,file))

#Function Start

# This function below is a little rubbish. 
def savefile(sequencer_list):
 outfile = open("./track.playpi","w")
 for w in range(0, len(sequencer_list)):
  for i in range(0, len(sequencer_list[w])):
        for j in range(0, len(sequencer_list[w][i])):
                        outfile.write(str(sequencer_list[w][i][j]))
                        x = j
                        x += 1
                        if x != len((sequencer_list[w][i])):
                                outfile.write(",")
        outfile.write("\n")
 
 outfile.close()
 return

# This is a litte rubbish to.
def loadfile(sequencer_list):
 infile = open("./track.playpi","r")
 inlist = infile.read()
 infile.close()
 counter = 0
 seqcounter = 0
 for i in inlist.split('\n'):
	if counter == 255:
                seqcounter += 1
 		counter = -1
	if i.strip():
                for j in i.split(','):
                        sequencer_list[seqcounter][counter].append(str(j))
        counter += 1
 return

def createsounddict(sequencer_list):
 global sounddict
 global exitfunction
 global special_sequence_options
 sounddict = {}
 dictlist = []
 # Go though every sequencer and place uniq samples in dictlist
 for seqcount in range(0, len(sequencer_list)):
 	for seq in range(0, len(sequencer_list[seqcount])):
 		for sample in range(0, len(sequencer_list[seqcount][seq])):
 			if sequencer_list[seqcount][seq][sample] not in dictlist:
 				dictlist.append(sequencer_list[seqcount][seq][sample])

 # Check and remove options.
 for special_item in special_sequence_options:
 	if special_item in dictlist:
 		dictlist.remove(special_item)

 # Load the samples into a dictionary and ref by sample location.
 for sample in range(0,len(dictlist)):
	sounddict[str(dictlist[sample])] = pygame.mixer.Sound(str(dictlist[sample]))
 return



def printmenu(list):
 global printoutmenu
 if printoutmenu == 1:
 	os.system("clear")
 	print "Print Menu - Start"
 	for item in list:
  		print item
  		printoutmenu = 0

def printsequence(sequence,stepstart,stepend):
 print "Print Sequence Start:"
 global printoutmenu
 global pattern
 counter = stepstart
 counter += 1
 
 if printoutmenu == 1:
	os.system("clear")
	# We need to Add 1 to the sequence count so people dont get confused.
	display_sequence = sequence 
	display_sequence += 1
	for step in range(stepstart,stepend):
		print counter,")",sequencer_list[sequence][step]
		counter += 1  
	print "Steps:",stepstart,"/",stepend, "Sequencer:", display_sequence,"/",len(sequencer_list)
	print "Pattern: ",pattern
	printoutmenu = 0
 return

def printpattern():
 global pattern
 global printoutmenu
 global currentsequence
 global sequencer_list
 global patstart
 global patend
 counter = 1

# Make sure users can only select valid index's
 if len(pattern) < patend:
	patrealend = len(pattern)
 else:
 	patrealend = patend

 if patstart < 0:
 	patstart = 0
	patend = 16
 elif patstart > len(pattern):
 	patstart = 0
 	patend = 16
 
 if printoutmenu == 1:
 	if len(pattern) < 16:
 		os.system("clear")
		for sequence in pattern:
			print counter,") Sequnce:",sequence
			counter +=1
		print "Sequencer:", currentsequence,"/",len(sequencer_list)
		print "Pattern: ",pattern
		printoutmenu = 0
	else:
		os.system("clear")
		for sequence in range(patstart,patrealend):
			print counter,") Sequence:",pattern[sequence]
			counter +=1
		print "Sequencer:", currentsequence,"/",len(sequencer_list)
		print "Pattern: ",pattern
		printoutmenu = 0
 print "Pat start/end",patstart,patend
 return
		

def printsamples(start,end):
 global current_sample_list 
 printoutmenu = 1
 counter = 1
 current_sample_list = []
 os.system("clear")
 for sample in range(start,end):
 	print counter ,")",sample_list[sample]
 	counter += 1
 	current_sample_list.append(sample_list[sample])
 printoutmenu = 0
 print menutitle[1]
 return

def sampleremove(button):
 global printoutmenu
 printoutmenu = 1
 print "Sample Add Remove - Start"
 print sample_list
 return

def playsample(sample):
 global current_sample_list 
 playcommand =['play']
 samplefile = current_sample_list[sample]
 playcommand.append(current_sample_list[sample])
 playcommand.append('-t')
 playcommand.append('alsa')
 cmd = playcommand
 subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
 printoutmenu = 1

def addtosequence(sample,current_sample_number):
 global currentsequence 
 global stepstart
 global stepend
 global sequencer_list
 global exitfunction
 global printoutmenu
 global printsamplestart
 global printsampleend
 global menutitle
 printoutmenu = 1
 printsequence(currentsequence,stepstart,stepend)
 print currentsequence
 print menutitle[2]
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                print "Add to sequence: You Pressed: ", button
                if button == "e":
                        exitfunction = 0
                        printoutmenu = 1
			printsamples(printsamplestart,printsampleend)
                elif button == "a":
                        stepstart -= 16
                        stepend -= 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[2]
                elif button == "b":
                        stepstart += 16
                        stepend += 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[2]
                elif button == "c":
                        currentsequence -= 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
			print menutitle[2]
                elif button == "d":
                        currentsequence += 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
			print menutitle[2]
                elif button <= 15 and button >= 0:
                        playsample(current_sample_number)
			# I shall change this when I find a better way to nap the numbers
			current_number = 0
			selected_step = 0
			for i in range(stepstart,stepend):
				if current_number == button:
					selected_step = i
				current_number += 1
			# Check to see if the sample is already there. If not the add it, if its there remove it.
			if sample in  sequencer_list[currentsequence][selected_step]:
				sequencer_list[currentsequence][selected_step].remove(sample)
			else:
				sequencer_list[currentsequence][selected_step].append(sample)
			printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
			print menutitle[2]
                else:
                        printoutmenu = 1

 	time.sleep(.1)
 exitfunction = 1
 return

 


def sampleadd(sequence):
 global exitfunction
 global printoutmenu
 global printsamplestart
 global printsampleend
 global currentsequence
 global menutitle
 printsamples(printsamplestart,printsampleend)
 while exitfunction != 0:
	if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == "e":
                        exitfunction = 0
                        printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
                elif button == "a":
                        printsamplestart -= 16
                        printsampleend -= 16
                        printoutmenu = 1
                        printsamples(printsamplestart,printsampleend)
                        print "current sample", printsamplestart, printsampleend 
                elif button == "b":
                        printsamplestart += 16
                        printsampleend += 16
                        printoutmenu = 1
                        printsamples(printsamplestart,printsampleend)
                        print "current sample", printsamplestart, printsampleend 
		elif button <= 15 and button >= 0:
			playsample(button)
			current_sample_selection = current_sample_list[button]
			current_sample_number = button
 			printsamples(printsamplestart,printsampleend)
			print "Current Sample Select=", current_sample_selection
		elif button == "f":
			addtosequence(current_sample_selection,current_sample_number)
			
                else:
                        printoutmenu = 1

	time.sleep(.1)
 exitfunction = 1
 return

def changetempo():
 global exitfunction
 global printoutmenu
 global tempo
 print "Change Temp - Start"
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == "e":
                        exitfunction = 0
                        printoutmenu = 1
                elif button == "a":
                        tempo -= 1
                        #print "Tempo", tempo 
                        print "-1" 
                elif button == "b":
                        tempo += 1
                        print "+1" 
                        #print "Tempo", tempo 
                elif button == "c":
                        tempo -= 5
                        #print "Tempo", tempo 
                        print "-5" 
                elif button == "d":
                        tempo += 5
                        #print "Tempo", tempo 
                        print "+5"
        time.sleep(.1)
 exitfunction = 1
 return

def patterneditor():
 global exitfunction
 global printoutmenu
 global currentsequence
 global stepstart
 global stepend
 global patstart
 global patend
 global menutitle
 global sequencer_list
 global pattern
 print menutitle[4]
 printoutmenu = 1
 printpattern()
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                print menutitle[4]
                if button == "e":
                        exitfunction = 0
                        printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
                elif button == "a":
                        patstart -= 16
                        patend -= 16
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == "b":
                        patstart += 16
                        patend += 16
                        printpattern()
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == "c":
                        currentsequence -= 1
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == "d":
                        currentsequence += 1
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == "g":
                        pattern.append(currentsequence)
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print menutitle[4]
                else:
                        printoutmenu = 1
        time.sleep(.1)
 exitfunction = 1
 printoutmenu = 1
 return


def patternbuilder():
 global exitfunction
 global printoutmenu
 global currentsequence
 global stepstart
 global stepend
 global menutitle
 global sequencer_list
 global pattern
 print menutitle[3]
 printoutmenu = 1
 printsequence(currentsequence,stepstart,stepend)
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == "e":
                        exitfunction = 0
                        printoutmenu = 1
                elif button == "f":
                        patterneditor()
                elif button == "a":
                        stepstart -= 16
                        stepend -= 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                elif button == "b":
                        stepstart += 16
                        stepend += 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                elif button == "c":
                        currentsequence -= 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                elif button == "d":
                        currentsequence += 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
		elif button == "g":
			pattern.append(currentsequence)
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
		elif button == "h":
			pattern.pop()
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                #elif button <= 15 and button >= 0:
                #elif button <= 15 and button >= 0:
                #        sampleremove(button)
                else:
                        printoutmenu = 1
        time.sleep(.1)
 exitfunction = 1
 return



	

def sequencerbuilder():
 global exitfunction
 global printoutmenu
 global currentsequence
 global stepstart
 global stepend
 global menutitle
 global sequencer_list
 undo = 0
 copylist = []
 undolist = []
 print "Sequencer Builder - Start"
 # Print out the sequence and step information for the user here before main loop starts, as main loop requires input to trigger.
 # printoutmenu needs to be set to 1 to let the out for the first time!
 printoutmenu = 1
 printsequence(currentsequence,stepstart,stepend)
 print menutitle[0]
 while exitfunction != 0:
	if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                print "Sequencer Builder: You Pressed: ", button
                if button == "e":
                        exitfunction = 0
 			printoutmenu = 1
		elif button == "f":
			sampleadd(currentsequence)
                elif button == "a":
                        stepstart -= 16
                        stepend	-= 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[0]
                elif button == "b":
                        stepstart += 16
                        stepend += 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[0]
		elif button == "c":
			currentsequence -= 1 
			printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
			print "current sequence", currentsequence 
 			print menutitle[0]
		elif button == "d":
			currentsequence += 1  
			printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
			print "current sequence", currentsequence 
 			print menutitle[0]
		elif button == "g":
			print "Copy Sequence"
			copylist = copy.deepcopy(sequencer_list[currentsequence])
		elif button == "h":
			if undo == 0:
				undolist = copy.deepcopy(sequencer_list[currentsequence])
				sequencer_list[currentsequence] = copy.deepcopy(copylist)
				printoutmenu = 1
 				printsequence(currentsequence,stepstart,stepend)
				undo = 1
				print "Paste Sequence"
			elif undo == 1:
				sequencer_list[currentsequence] = copy.deepcopy(undolist)
				printoutmenu = 1
 				printsequence(currentsequence,stepstart,stepend)
				undo = 0
				print "Undo Paste Sequence"
		elif button <= 15 and button >= 0:
			sampleremove(button)
		else:
			printoutmenu = 1

	time.sleep(.1)
 exitfunction = 1
 return

 

def mainmenu():
 global exitprogram
 global sequencer_status
 global sequencer_mode
 global sequencer_mode_current
 while exitprogram != 0:
 	printmenu(firstmenu)
	if not buttonQueue.empty():
		queueLock.acquire()
        	button = buttonQueue.get()
		buttonQueue.task_done()
        	queueLock.release()
		print "Menu: You Pressed: ", button
		if button == "e":
			print "Time to exit"
			exitprogram = 0
		elif button == "h":
			if sequencer_status == 0:
				sequencer_status = 1
			elif sequencer_status == 1:
				sequencer_status = 0
		elif button == "g":
			if sequencer_mode_current == 0:
				sequencer_mode_current = 1
			else:
				sequencer_mode_current = 0
		elif button == 0:
			sequencerbuilder()
		elif button == 1:
			patternbuilder()
		elif button == 2:
			createsounddict(sequencer_list)
		elif button == 3:
			changetempo()
		elif button == 4:
			loadfile(sequencer_list)
		elif button == 5:
			savefile(sequencer_list)
	time.sleep(.1)
 return

mainmenu = threading.Thread(target=mainmenu, args=[])
mainmenu.start()

def sequencer():
 global sequencer_list
 global sequencer_status
 global exitprogram
 global sounddict
 global tempo
 global currentsequence
 global currentstep
 global special_sequence_options 
 global sequencer_mode_current 
 global pattern_sequence 
 ENDHIT = "0"
 while exitprogram != 0:
	while sequencer_status == 1 :
 		# Stop the sequencer if we have been told to exit
 		if exitprogram == 0:
			sequencer_status = 0
		if sequencer_mode_current == 0:
		 for step in sequencer_list[currentsequence]:
			# The line bellow has a bug I need to look into.
			# currentstep = sequencer_list[currentsequence].index(step)
        		samplecount = len(step)
			if ENDHIT == "1":
				ENDHIT = "0"
				break
                	for sample in range(0, samplecount):
				if step[sample] == "END":
                                	ENDHIT="1"	
				if step[sample] not in special_sequence_options:
					cx = pygame.mixer.find_channel()
					cx.play(sounddict[step[sample]])
			sleeptime = ((60/tempo)-0.125)
 		        time.sleep(sleeptime)
		elif sequencer_mode_current == 1:
		 for pattern_sequence in pattern:
			if sequencer_mode_current == 0:
				break
			if exitprogram == 0:
				break
			for step in sequencer_list[pattern_sequence]:
                        	samplecount = len(step)
                        	if ENDHIT == "1":
                               		ENDHIT = "0"
                                	break
                        	for sample in range(0, samplecount):
                                	if step[sample] == "END":
                                        	ENDHIT="1"
                                	if step[sample] not in special_sequence_options:
                                        	cx = pygame.mixer.find_channel()
                                        	cx.play(sounddict[step[sample]])
                        	sleeptime = ((60/tempo)-0.125)
                        	time.sleep(sleeptime)

	time.sleep(.500)
 return

sequencer = threading.Thread(target=sequencer, args=[])
sequencer.start()


def audio_playback(step):
 global sequencer_list
 global tempo
 global sounddict

# Thread for led and on screen info display
def display():
 global exitprogram
 global tempo
 global currentsequence
 global totalsequence
 global currentstep
 global sequencer_mode
 global sequencer_mode_current
 global sequencer_status
 global sequencer_status_display
 global pattern_sequence 

 x = 1
 f = 256
 i = 1
 
 while exitprogram != 0:
 		displaysequence = currentsequence +1
#               sys.stdout.write ("\x1b7\x1b[%d;%d,%df%s\x1b8" % (50, 0, "Step"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (29, 0, "Playback: [",sequencer_status_display[sequencer_status],"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (30, 0, "Playback Type: [",sequencer_mode[sequencer_mode_current],"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 0, "Steps: [",currentstep,"/",f,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 20, "Sequence: [",displaysequence,"/",totalsequence,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 40, "Channels: [",x,"/",i,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 60, "Samples: [",i,"/",i,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (31, 80, "Tempo: [",tempo,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (31, 100, "Pattern: [",pattern_sequence,"]"))
                sys.stdout.flush()
                time.sleep(.2)
 

threading.Thread(target = display).start()

def buttons():

# Globals
 global exitprogram
 while exitprogram != 0:
	global action
	for character in pipe.read(1):
		action += ['%02X' % ord(character)]
		if len(action) == 8:


			num = int(action[5], 16) # Translate back to integer form
			percent254 = str(((float(num)-128.0)/126.0)-100)[4:6] # Calculate the percentage of push
			percent128 = str((float(num)/127.0))[2:4]

			if percent254 == '.0':
				percent254 = '100'
			if percent128 == '0':
				percent128 = '100'

			if action[6] == '01': # Button
				if action[4] == '01':
					if action[7] == '03':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(0)
					if action[7] == '07':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(1)
					if action[7] == '01':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(2)
					if action[7] == '00':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(3)
					if action[7] == '02':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(4)
					if action[7] == '06':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(5)
					if action[7] == '05':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(6)
					if action[7] == '08':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(7)
					if action[7] == '0A':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(8)
					if action[7] == '0E':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(9)
					if action[7] == '11':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(10)
					if action[7] == '13':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(11)
					if action[7] == '12':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(12)
					if action[7] == '14':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(13)
					if action[7] == '0D':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(14)
					if action[7] == '0B':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put(15)
					if action[7] == '04':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put("a")
					if action[7] == '09':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put("b")
					if action[7] == '10':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put("c")
					if action[7] == '15':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put("d")
					if action[7] == '0C':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put("e")
					if action[7] == '0F':
						#print 'You pressed button: opt7' + action[7]
						buttonQueue.put("g")

			if action[6] == '02': # Joystick Hack
				if action[4] == 'FF':
					if action[7] == '02':
						#print 'You pressed button: ' + action[7]
						buttonQueue.put("f")
					if action[7] == '03':
						#print 'You pressed button opt8: ' + action[7]
						buttonQueue.put("h")

			action = []
			time.sleep(.1)
 return


buttons = threading.Thread(target=buttons, args=[])
buttons.start()

